diff -u -r nginx-1.0.4/src/core/ngx_conf_file.c nginx-1.0.4-patched/src/core/ngx_conf_file.c
--- nginx-1.0.4/src/core/ngx_conf_file.c	2011-04-12 10:02:46.000000000 +0200
+++ nginx-1.0.4-patched/src/core/ngx_conf_file.c	2011-06-04 07:01:35.000000000 +0200
@@ -714,6 +714,11 @@
                             *dst++ = '\n';
                             src += 2;
                             continue;
+
+                        case '0':
+                            *dst++ = '\0';
+                            src += 2;
+                            continue;
                         }
 
                     }
diff -u -r nginx-1.0.4/src/core/ngx_inet.c nginx-1.0.4-patched/src/core/ngx_inet.c
--- nginx-1.0.4/src/core/ngx_inet.c	2011-04-15 15:50:27.000000000 +0200
+++ nginx-1.0.4-patched/src/core/ngx_inet.c	2011-06-04 07:18:16.000000000 +0200
@@ -574,7 +574,8 @@
     u->socklen = sizeof(struct sockaddr_un);
     saun = (struct sockaddr_un *) &u->sockaddr;
     saun->sun_family = AF_UNIX;
-    (void) ngx_cpystrn((u_char *) saun->sun_path, path, len);
+    ngx_memcpy(saun->sun_path, path, len);
+    saun->sun_path[len-1] = 0;
 
     u->addrs = ngx_pcalloc(pool, sizeof(ngx_addr_t));
     if (u->addrs == NULL) {
@@ -590,10 +591,17 @@
     u->naddrs = 1;
 
     saun->sun_family = AF_UNIX;
-    (void) ngx_cpystrn((u_char *) saun->sun_path, path, len);
+    ngx_memcpy(saun->sun_path, path, len);
+    saun->sun_path[len-1] = 0;
 
     u->addrs[0].sockaddr = (struct sockaddr *) saun;
-    u->addrs[0].socklen = sizeof(struct sockaddr_un);
+    if (saun->sun_path[0] != '\0') {
+        u->addrs[0].socklen = sizeof(struct sockaddr_un);
+    }
+    else {
+        u->addrs[0].socklen = sizeof(saun->sun_family) + len;
+    }
+
     u->addrs[0].name.len = len + 4;
     u->addrs[0].name.data = u->url.data;
 
